
struct mouse_event {
	int code;
	unsigned char button;
	unsigned char state;	/* buttons and shifts */
	int x, y, wy;
};

int getkey();
const struct mouse_event *getmouse();
extern int getkey_utf8;

#define kENTER	0x1000000
#define kBS	0x1000001
#define kTAB	0x1000002
#define kESC	0x1000003
#define kLEFT	0x1000004
#define kRIGHT	0x1000005
#define kUP	0x1000006
#define kDOWN	0x1000007
#define kINS	0x1000008
#define kDEL	0x1000009
#define kHOME	0x100000a
#define kEND	0x100000b
#define kPGUP	0x100000c
#define kPGDN	0x100000d
#define kCENTER	0x1000010
#define kWINL	0x1000011
#define kWINR	0x1000012
#define kMENU	0x1000013
#define kSCRUP	0x1000014
#define kSCRDN	0x1000015

#define kF1	0x1000020
#define kF2	0x1000021
#define kF3	0x1000022
#define kF4	0x1000023
#define kF5	0x1000024
#define kF6	0x1000025
#define kF7	0x1000026
#define kF8	0x1000027
#define kF9	0x1000028
#define kF10	0x1000029
#define kF11	0x100002a
#define kF12	0x100002b
#define kF13	0x100002c
#define kF14	0x100002d
#define kF15	0x100002e
#define kF16	0x100002f
#define kF17	0x1000030
#define kF18	0x1000031
#define kF19	0x1000032
#define kF20	0x1000033
#define kF21	0x1000034
#define kF22	0x1000035

#define kMOUSE	0x8000000

#define kmPRESS 1
#define kmRELEASE 2
#define kmDRAG 3
#define kmMOVE 4
#define kmWHEEL 5

#define k_BUTTON1	1
#define k_BUTTON2	2
#define k_BUTTON3	4

#define kCPOS	0x9000000
#define kDECID	0x9010000
#define kTERM_T	0xA000000
#define kTSIZE	0xA080000

#define kMASK	0x0FFFFFFF
#define kMODIF	0xF0000000

#define kSHIFT	0x10000000
#define kALT	0x20000000
#define kCTRL	0x40000000

#define kNOKEY 0
#define kMORE -1
#define kERROR -2
#define kINCOMPLETE -3 /* internal */

/* old names */
#if 0
#define	KBD_ENTER	kENTER
#define	KBD_BS		kBS
#define	KBD_TAB		kTAB
#define	KBD_ESC		kESC
#define	KBD_LEFT	kLEFT
#define	KBD_RIGHT	kRIGHT
#define	KBD_UP		kUP
#define	KBD_DOWN	kDOWN
#define	KBD_INS		kINS
#define	KBD_DEL		kDEL
#define	KBD_HOME	kHOME
#define	KBD_END		kEND
#define	KBD_PAGE_UP	kPGUP
#define	KBD_PAGE_DOWN	kPGDN
#define	KBD_CENTER	kCENTER
#define	KBD_WINL	kWINL
#define	KBD_WINR	kWINR
#define	KBD_MENU	kMENU

#define	KBD_F1	kF1
#define	KBD_F2	kF2
#define	KBD_F3	kF3
#define	KBD_F4	kF4
#define	KBD_F5	kF5
#define	KBD_F6	kF6
#define	KBD_F7	kF7
#define	KBD_F8	kF8
#define	KBD_F9	kF9
#define	KBD_F10	kF10
#define	KBD_F11	kF11
#define	KBD_F12	kF12

#define	KBD_F13	kF13
#define	KBD_F14	kF14
#define	KBD_F15	kF15
#define	KBD_F16	kF16
#define	KBD_F17	kF17
#define	KBD_F18	kF18
#define	KBD_F19	kF19
#define	KBD_F20	kF20

#define	KBD_MOUSE	kMOUSE

#define	KBD_CPOS	kCPOS
#define	KBD_DECID	kDECID
#define	KBD_TERM_T	kTERM_T
#define	KBD_TSIZE	kTSIZE

#define	KBD_MASK	kMASK

#define	KBD_SHIFT	kSHIFT
#define	KBD_ALT		kALT
#define	KBD_CTRL	kCTRL

#define	KBD_NOKEY	kNOKEY
#define	KBD_MORE	kMORE
#define	KBD_ERROR	kERROR
#endif
